xref: /linux/scripts/link-vmlinux.sh (revision 42b16d3ac371a2fac9b6f08fd75f23f34ba3955a)
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects in vmlinux.a and $(KBUILD_VMLINUX_LIBS).
7# vmlinux.a contains objects that are linked unconditionally.
8# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
9# (not within --whole-archive), and do not require symbol indexes added.
10#
11# vmlinux
12#   ^
13#   |
14#   +--< vmlinux.a
15#   |
16#   +--< $(KBUILD_VMLINUX_LIBS)
17#   |    +--< lib/lib.a + more
18#   |
19#   +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31LD="$1"
32KBUILD_LDFLAGS="$2"
33LDFLAGS_vmlinux="$3"
34
35is_enabled() {
36	grep -q "^$1=y" include/config/auto.conf
37}
38
39# Nice output in kbuild format
40# Will be supressed by "make -s"
41info()
42{
43	printf "  %-7s %s\n" "${1}" "${2}"
44}
45
46# Link of vmlinux
47# ${1} - output file
48vmlinux_link()
49{
50	local output=${1}
51	local objs
52	local libs
53	local ld
54	local ldflags
55	local ldlibs
56
57	info LD ${output}
58
59	# skip output file argument
60	shift
61
62	if is_enabled CONFIG_LTO_CLANG || is_enabled CONFIG_X86_KERNEL_IBT; then
63		# Use vmlinux.o instead of performing the slow LTO link again.
64		objs=vmlinux.o
65		libs=
66	else
67		objs=vmlinux.a
68		libs="${KBUILD_VMLINUX_LIBS}"
69	fi
70
71	if is_enabled CONFIG_MODULES; then
72		objs="${objs} .vmlinux.export.o"
73	fi
74
75	objs="${objs} init/version-timestamp.o"
76
77	if [ "${SRCARCH}" = "um" ]; then
78		wl=-Wl,
79		ld="${CC}"
80		ldflags="${CFLAGS_vmlinux}"
81		ldlibs="-lutil -lrt -lpthread"
82	else
83		wl=
84		ld="${LD}"
85		ldflags="${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}"
86		ldlibs=
87	fi
88
89	ldflags="${ldflags} ${wl}--script=${objtree}/${KBUILD_LDS}"
90
91	# The kallsyms linking does not need debug symbols included.
92	if [ -n "${strip_debug}" ] ; then
93		ldflags="${ldflags} ${wl}--strip-debug"
94	fi
95
96	if is_enabled CONFIG_VMLINUX_MAP; then
97		ldflags="${ldflags} ${wl}-Map=${output}.map"
98	fi
99
100	${ld} ${ldflags} -o ${output}					\
101		${wl}--whole-archive ${objs} ${wl}--no-whole-archive	\
102		${wl}--start-group ${libs} ${wl}--end-group		\
103		${kallsymso} ${btf_vmlinux_bin_o} ${ldlibs}
104}
105
106# generate .BTF typeinfo from DWARF debuginfo
107# ${1} - vmlinux image
108gen_btf()
109{
110	local btf_data=${1}.btf.o
111
112	info BTF "${btf_data}"
113	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
114
115	# Create ${btf_data} which contains just .BTF section but no symbols. Add
116	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
117	# deletes all symbols including __start_BTF and __stop_BTF, which will
118	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
119	# objcopy warnings: "empty loadable segment detected at ..."
120	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
121		--strip-all ${1} "${btf_data}" 2>/dev/null
122	# Change e_type to ET_REL so that it can be used to link final vmlinux.
123	# GNU ld 2.35+ and lld do not allow an ET_EXEC input.
124	if is_enabled CONFIG_CPU_BIG_ENDIAN; then
125		et_rel='\0\1'
126	else
127		et_rel='\1\0'
128	fi
129	printf "${et_rel}" | dd of="${btf_data}" conv=notrunc bs=1 seek=16 status=none
130
131	btf_vmlinux_bin_o=${btf_data}
132}
133
134# Create ${2}.o file with all symbols from the ${1} object file
135kallsyms()
136{
137	local kallsymopt;
138
139	if is_enabled CONFIG_KALLSYMS_ALL; then
140		kallsymopt="${kallsymopt} --all-symbols"
141	fi
142
143	if is_enabled CONFIG_KALLSYMS_ABSOLUTE_PERCPU; then
144		kallsymopt="${kallsymopt} --absolute-percpu"
145	fi
146
147	info KSYMS "${2}.S"
148	scripts/kallsyms ${kallsymopt} "${1}" > "${2}.S"
149
150	info AS "${2}.o"
151	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
152	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} -c -o "${2}.o" "${2}.S"
153
154	kallsymso=${2}.o
155}
156
157# Perform kallsyms for the given temporary vmlinux.
158sysmap_and_kallsyms()
159{
160	mksysmap "${1}" "${1}.syms"
161	kallsyms "${1}.syms" "${1}.kallsyms"
162
163	kallsyms_sysmap=${1}.syms
164}
165
166# Create map file with all symbols from ${1}
167# See mksymap for additional details
168mksysmap()
169{
170	info NM ${2}
171	${NM} -n "${1}" | sed -f "${srctree}/scripts/mksysmap" > "${2}"
172}
173
174sorttable()
175{
176	${objtree}/scripts/sorttable ${1}
177}
178
179cleanup()
180{
181	rm -f .btf.*
182	rm -f System.map
183	rm -f vmlinux
184	rm -f vmlinux.map
185}
186
187# Use "make V=1" to debug this script
188case "${KBUILD_VERBOSE}" in
189*1*)
190	set -x
191	;;
192esac
193
194if [ "$1" = "clean" ]; then
195	cleanup
196	exit 0
197fi
198
199${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
200
201btf_vmlinux_bin_o=
202kallsymso=
203strip_debug=
204
205if is_enabled CONFIG_KALLSYMS; then
206	true > .tmp_vmlinux.kallsyms0.syms
207	kallsyms .tmp_vmlinux.kallsyms0.syms .tmp_vmlinux0.kallsyms
208fi
209
210if is_enabled CONFIG_KALLSYMS || is_enabled CONFIG_DEBUG_INFO_BTF; then
211
212	# The kallsyms linking does not need debug symbols, but the BTF does.
213	if ! is_enabled CONFIG_DEBUG_INFO_BTF; then
214		strip_debug=1
215	fi
216
217	vmlinux_link .tmp_vmlinux1
218fi
219
220if is_enabled CONFIG_DEBUG_INFO_BTF; then
221	if ! gen_btf .tmp_vmlinux1; then
222		echo >&2 "Failed to generate BTF for vmlinux"
223		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
224		exit 1
225	fi
226fi
227
228if is_enabled CONFIG_KALLSYMS; then
229
230	# kallsyms support
231	# Generate section listing all symbols and add it into vmlinux
232	# It's a four step process:
233	# 0)  Generate a dummy __kallsyms with empty symbol list.
234	# 1)  Link .tmp_vmlinux.kallsyms1 so it has all symbols and sections,
235	#     with a dummy __kallsyms.
236	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
237	#     the right size
238	# 2)  Link .tmp_vmlinux.kallsyms2 so it now has a __kallsyms section of
239	#     the right size, but due to the added section, some
240	#     addresses have shifted.
241	#     From here, we generate a correct .tmp_vmlinux.kallsyms2.o
242	# 3)  That link may have expanded the kernel image enough that
243	#     more linker branch stubs / trampolines had to be added, which
244	#     introduces new names, which further expands kallsyms. Do another
245	#     pass if that is the case. In theory it's possible this results
246	#     in even more stubs, but unlikely.
247	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
248	#     other bugs.
249	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
250	#
251	# a)  Verify that the System.map from vmlinux matches the map from
252	#     ${kallsymso}.
253
254	# The kallsyms linking does not need debug symbols included.
255	strip_debug=1
256
257	sysmap_and_kallsyms .tmp_vmlinux1
258	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
259
260	vmlinux_link .tmp_vmlinux2
261	sysmap_and_kallsyms .tmp_vmlinux2
262	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
263
264	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
265		vmlinux_link .tmp_vmlinux3
266		sysmap_and_kallsyms .tmp_vmlinux3
267	fi
268fi
269
270strip_debug=
271
272vmlinux_link vmlinux
273
274# fill in BTF IDs
275if is_enabled CONFIG_DEBUG_INFO_BTF; then
276	info BTFIDS vmlinux
277	${RESOLVE_BTFIDS} vmlinux
278fi
279
280mksysmap vmlinux System.map
281
282if is_enabled CONFIG_BUILDTIME_TABLE_SORT; then
283	info SORTTAB vmlinux
284	if ! sorttable vmlinux; then
285		echo >&2 Failed to sort kernel tables
286		exit 1
287	fi
288fi
289
290# step a (see comment above)
291if is_enabled CONFIG_KALLSYMS; then
292	if ! cmp -s System.map "${kallsyms_sysmap}"; then
293		echo >&2 Inconsistent kallsyms data
294		echo >&2 'Try "make KALLSYMS_EXTRA_PASS=1" as a workaround'
295		exit 1
296	fi
297fi
298
299# For fixdep
300echo "vmlinux: $0" > .vmlinux.d
301